SystemOrganization addCategory: #HashProof!
SystemOrganization addCategory: #'HashProof-Example'!

Trait named: #CoreHashProofTrait
	uses: {}
	category: 'HashProof'!

Trait named: #ClassCheckingHashProofTrait
	uses: CoreHashProofTrait
	category: 'HashProof'!

ClassCheckingHashProofTrait classTrait
	uses: CoreHashProofTrait classTrait!

!ClassCheckingHashProofTrait methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:16'!
= anObject
	self == anObject ifTrue: [^true].
	self class ~= anObject class ifTrue: [^false].
	^self gettersForEquality allSatisfy: [:symbol| (self perform: symbol) = (anObject perform: symbol) ]
	! !

!CoreHashProofTrait methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/7/2012 22:03'!
hash

	^self gettersForEquality inject: 0 into: [:hash :symbol| (hash fastBitShift7 hash) bitXor: (self perform: symbol) hash]! !

Trait named: #HashProofTrait
	uses: CoreHashProofTrait
	category: 'HashProof'!

HashProofTrait classTrait
	uses: CoreHashProofTrait classTrait!

!HashProofTrait methodsFor: 'as yet unclassified' stamp: 'hjo 7/8/2012 13:37'!
= anObject
	self == anObject ifTrue: [^true].
	^self gettersForEquality allSatisfy: [:symbol| (self perform: symbol) = (anObject perform: symbol) ]
	! !

Trait named: #ProtocolCheckingHashProofTrait
	uses: CoreHashProofTrait
	category: 'HashProof'!

ProtocolCheckingHashProofTrait classTrait
	uses: CoreHashProofTrait classTrait!

!ProtocolCheckingHashProofTrait methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 18:51'!
= anObject
	self == anObject ifTrue: [^true].
	(self gettersForEquality allSatisfy: [:symbol| anObject respondsTo: symbol]) ifFalse: [^false].
	^self gettersForEquality allSatisfy: [:symbol| (self perform: symbol) = (anObject perform: symbol) ]
	! !

!Integer methodsFor: '*HashProof' stamp: 'HwaJong 11/7/2012 22:02'!
fastBitShift7
|lowMask highMask lowBits highBits|
lowMask := 2r000000011111111111111111111111.
highMask :=  2r111111100000000000000000000000.
lowBits := self bitAnd: lowMask.
highBits := self bitAnd: highMask.
^lowBits * 128 + (highBits //  8388608).! !

Object subclass: #HashProofUseExample
	uses: HashProofTrait
	instanceVariableNames: 'x y z'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HashProof-Example'!

HashProofUseExample class
	uses: HashProofTrait classTrait
	instanceVariableNames: ''!

!HashProofUseExample methodsFor: 'as yet unclassified' stamp: ''!
= anObject

	^self gettersForEquality allSatisfy: [:symbol| (self perform: symbol) = (anObject perform: symbol) ]
	! !

!HashProofUseExample methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 17:55'!
gettersForEquality

	^{#x . #y. #z}! !

!HashProofUseExample methodsFor: 'as yet unclassified' stamp: ''!
hash

	^(self gettersForEquality inject: 0 into: [:hash :symbol| hash bitXor: (self perform: symbol) hash]) hash! !

!HashProofUseExample methodsFor: 'accessing' stamp: 'hjo 9/13/2011 17:51'!
x
	^ x! !

!HashProofUseExample methodsFor: 'accessing' stamp: 'hjo 9/13/2011 17:51'!
x: anObject
	x := anObject! !

!HashProofUseExample methodsFor: 'accessing' stamp: 'hjo 9/13/2011 17:51'!
y
	^ y! !

!HashProofUseExample methodsFor: 'accessing' stamp: 'hjo 9/13/2011 17:51'!
y: anObject
	y := anObject! !

!HashProofUseExample methodsFor: 'accessing' stamp: 'hjo 9/13/2011 17:51'!
z
	^ z! !

!HashProofUseExample methodsFor: 'accessing' stamp: 'hjo 9/13/2011 17:51'!
z: anObject
	z := anObject! !
